'''
高自定义的强效消音器
'''
from .silencer import *
from nonebot.plugin import PluginMetadata

__plugin_meta__ = PluginMetadata(
    name="消音器",
    description="可以晋级的屏蔽词消息拦截插件，自动、手动两档拉黑用户与群聊，针对顽固污渍实施高效清洁",
    usage="""
    消音 [t 8-12位整数时间] [g 群id] [u 用户id]
    解除消音 [g 群id] [u 用户id]
    添加消音词 [领域] [词 词]
    删除消音词 [词 词]
    """,
    type="application",
    # 发布必填，当前有效类型有：`library`（为其他插件编写提供功能），`application`（向机器人用户提供功能）。
    homepage="https://github.com/youlanan/nonebot-plugin-tea-silencer",
    # 发布必填。
    config=silencer.ConfigModel,
    supported_adapters={"~onebot.v11"},
    # 支持的适配器集合，其中 `~` 在此处代表前缀 `nonebot.adapters.`，其余适配器亦按此格式填写。
    # 若插件可以保证兼容所有适配器（即仅使用基本适配器功能）可不填写，否则应该列出插件支持的适配器。
)

'''

    使用文档：
      详见: https://github.com/youlanan/nonebot-plugin-tea-silencer


    设计思路：
      仅供参考，实际功能应当以程序实现为主

      警告：
      以下内容晦涩难懂、意识流、非常规非专业、没有实际帮助，
      浏览它们你将获得：浪费五分钟生命。

      · 需要阻断脏话，智能屏蔽或拉黑
      · 需要bot管理员可手动加入与解除黑名单
      · 用户与群聊都需要进行屏蔽
      · 需要高度可自定义，以适应不同环境下需求
        · 在野生且管理员情况下将屏蔽改为禁言（仅想法，目前没有条件尝试适配）

      · 怎么智能？
        - 词库分类：常用敏感词种类包括：色情、政治、违法、广告+网址、侮辱等，【设置停用某词库将不加载】
        - 数值化：按性质为用户增加不同“分贝”数值，当分贝过高时触发对应等级的屏蔽
        - 群与用户：分别建立不同的分贝计算规则

      · 分贝等级：你想挑战屏蔽时长吗？
        - 划分等级：
          等级直接借鉴光遇游戏地图顺序：【晨岛、云野、雨林、霞谷、暮土、禁阁、伊甸之眼】
          每个阶段，都一定是触发多次才能继续升等。
          对应屏蔽时间为：半小时、三小时、一天、一周、一月、半年、一年
          【当然可以动态调整，减少等级划分、自定义屏蔽时间、修改升级所需分贝】
        - 临时缓存：
          由于数值化，用户触发则记录分贝到用户和触发群名下，
          但不会永久缓存，这是因为我们不能确定违禁词是否为误触，或仅为玩家好奇尝试。
          【一段时间】或重启后失忆。
        - 永久化记录：
          为了防止好奇心太重的玩家被永封，只有用户等级达到【转折点等级】时才会存入数据库。
          存入数据库的玩家将在下次触发时开始累加分贝等级。
        - 群封禁：
          考虑到可能会被违禁人士恶意爆破，请超管预留联系方式
          群违禁与玩家记录方式一致，【群升级所需分贝是用户的3倍，可调整】

      · 回复模式
        - 温馨提示（仅提示）
        - 软弱可欺（你惹到了棉花）
        - 飞马令（暖心问候）
        - 自定义按分贝等级混搭

      · 回复语参考
        - [消音器] 恭喜你，你的分贝已达到‘伊甸’级别，喜提黑名单时长：一 整 年~
        - [消音器] 温馨提示，本群已有三人以上触发违禁词，已为本群开启分贝累计~

      · 程序思路
        - 使用整数时间格式作为参数，方便输入（/添加|解除消音 t-20240817 u-xxxx xxxx g-xxxx xxxx）
        - 可以增删屏蔽词，（/添加|删除屏蔽词 领域 词词词）
        - 使用json方便查看 增删与字典同步
        - 在框架启动时将违禁词载入为表达式，以减少消息处理耗时
        - 提供两个违禁词查询方法，以使其他插件可以方便调用词库（好像指令都拦截了，也没啥用）
        - 拿注释当代码写（大雾）

      · 悠岚岸  - 2024年8月17日草稿

'''